<%@ Page Language="C#" %>

<% 
/////////////////////////////////////////////////////////////////////////////
//                                ipcheck.aspx
//                            -------------------
//   begin                : Thur, June 15, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: ipcheck.aspx,v 1.0.0.0 R1
//   Function: IP detection file.
//
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;

//MintDNSLib.DNSMANClass sd = new MintDNSLib.DNSMANClass();
String MyIP = Request.ServerVariables["HTTP_X_FORWARDED_FOR"];


     
    //IP detection
    if (MyIP != null)
    {
        MyIP = MyIP.ToLower();
        MyIP = MyIP.Trim();
    }

    if ((MyIP == null) || (MyIP == "unknown")) { MyIP = Request.ServerVariables["REMOTE_ADDR"]; }

    else if (MyIP.IndexOf(",") != -1)
    {
        string[] IPs = MyIP.Split(',');
        //MyIP = IPs.GetValue(IPs.Length -1).ToString().Trim();
          MyIP = IPs.GetValue(0).ToString().Trim();
    }
    if (IsValidIP(MyIP) != "false") { Response.Write(MyIP); }
    else { Response.Write("IP detection failed"); }

    Dispose();

%>

<script runat="server">

    string IsValidIP(string addr)
    {
        string valid = "false";
        string pattern = @"^([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3}$";
        string pattern1 = @"\A(?:[0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}\z";
        string pattern2 = @"\A((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?)::((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?)\z";
        string pattern3 = @"\A((?:[0-9A-Fa-f]{1,4}:){6,6})(25[0-5]|2[0-4]\d|[0-1]?\d?\d)(\.(25[0-5]|2[0-4]\d|[0-1]?\d?\d)){3}\z";
        string pattern4 = @"\A((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?) ::((?:[0-9A-Fa-f]{1,4}:)*)(25[0-5]|2[0-4]\d|[0-1]?\d?\d)(\.(25[0-5]|2[0-4]\d|[0-1]?\d?\d)){3}\z";
        Regex check = new Regex(pattern);
        Regex check1 = new Regex(pattern1);
        Regex check2 = new Regex(pattern2);
        Regex check3 = new Regex(pattern3);
        Regex check4 = new Regex(pattern4);
        if (check.IsMatch(addr, 0) == true) { valid = "ip4"; }
        if (check1.IsMatch(addr, 0) == true) { valid = "ip6"; }
        if (check2.IsMatch(addr, 0) == true) { valid = "ip6"; }
        if (check3.IsMatch(addr, 0) == true) { valid = "ip6"; }
        if (check4.IsMatch(addr, 0) == true) { valid = "ip6"; }
        return valid;
    }  
</script>