USE [mintdata]
GO
DECLARE @TableName varchar(255) 

DECLARE TableCursor CURSOR FOR 
SELECT table_name FROM information_schema.tables 
WHERE table_type = 'base table' 

OPEN TableCursor 

FETCH NEXT FROM TableCursor INTO @TableName 
WHILE @@FETCH_STATUS = 0 
BEGIN 
DBCC DBREINDEX(@TableName,' ',50) 
FETCH NEXT FROM TableCursor INTO @TableName 
END 

CLOSE TableCursor 

DEALLOCATE TableCursor
GO
BACKUP DATABASE mintdata
/*Change Path Below*/
TO DISK = 'C:\backup\DDNSDB.Bak'
   WITH FORMAT,
      MEDIANAME = 'C_DDNSBackups',
      NAME = 'Full Backup of DDNS Database';
GO
DBCC SHRINKDATABASE (mintdata, 10)
GO