<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<!--#include file="includes/css.aspx"-->

<% 
/////////////////////////////////////////////////////////////////////////////
//                                en-disdev.aspx
//                            -------------------
//   begin                : Thur, June 15, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: en-disdev,v 1.0.0.0 R1
//   Function: Device manager action file. (Enable, Disable Domain).
//
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;


MintDNSLib.DNSMANClass sd = new MintDNSLib.DNSMANClass();
if (Request.Cookies["DDNS"] == null) { Response.Redirect("logon.aspx?error=session"); }       
String Userid = Request.Cookies["DDNS"]["user"].ToString();
String Password = Request.Cookies["DDNS"]["pass"].ToString();
String URL = Request["url"];
String Action = Request["action"];
String MyIp = Request["myip"];
String UperCheck = "";
SqlConnection Conn = new SqlConnection(ConfigurationSettings.AppSettings["DBCon"]);
Conn.Open();

SqlCommand Ulook = new SqlCommand("User_Lookup @UserID='" + Userid + "', @Password='" + Password + "'", Conn);
SqlDataReader UlookSet = Ulook.ExecuteReader();
    if (UlookSet.HasRows == false) { Response.Redirect("logon.aspx?error=session"); }
    UlookSet.Close();
    Ulook.Dispose();


    if ((Action == null) || (Action == "") || (URL == null) || (URL == "")) { Response.Redirect("eddev.aspx?error=fields&url=" + URL); }
    if ((Action != "Enable") && (Action != "Disable")) { Response.Redirect("eddev.aspx?error=errt&url=" + URL); }
    if (IsOKurl(URL) == false)  { Response.Redirect("eddev.aspx?error=input&url=" + URL); }

    if (Action == "Enable") {
        SqlCommand DisLook = new SqlCommand("Enable_Device @URL='" + URL + "', @UserID='" + Userid + "', @Password='" + Password + "'", Conn);
        SqlDataReader DisSet = DisLook.ExecuteReader();
        while (DisSet.Read())
        {

            if (DisSet["result"].ToString() == "fail") { Response.Redirect("eddev.aspx?error=errt&url=" + URL); }
            if (DisSet["result"].ToString() == "ok") { 
           if (IsValidIP(DisSet["IP"].ToString()) == "ip4") { UperCheck = sd.UpdateARecord(DisSet["Host"].ToString(), DisSet["Dom"].ToString(), DisSet["IP"].ToString()); }
           if (IsValidIP(DisSet["IP"].ToString()) == "ip6") { UperCheck = sd.UpdateIP6(DisSet["Host"].ToString(), DisSet["Dom"].ToString(), DisSet["IP"].ToString());}
        }
        }
        
        Response.Redirect("eddev.aspx?error=enabled&url=" + URL);
        DisSet.Close();
        DisLook.Dispose();
    }
    else if (Action == "Disable") {
        String OlIPType = "";
        SqlCommand reclook = new SqlCommand("Record_IP_Type @URL='" + URL + "', @UserID='" + Userid + "', @Password='" + Password + "'", Conn);
        SqlDataReader RecdSet = reclook.ExecuteReader();
        while (RecdSet.Read()) { OlIPType = RecdSet["IP"].ToString(); }
        RecdSet.Close();
        reclook.Dispose();

        SqlCommand Enlook = new SqlCommand("Disable_Device_IP @URL='" + URL + "', @UserID='" + Userid + "', @Password='" + Password + "', @IPType='" + IsValidIP(OlIPType) + "'", Conn);
        SqlDataReader EnSet = Enlook.ExecuteReader();
        //if (EnSet.HasRows == false) { Response.Redirect("eddev.aspx?error=errt&url=" + URL); }
      
            while (EnSet.Read())
            {
                if (EnSet["result"].ToString() == "fail") { Response.Redirect("eddev.aspx?error=errt&url=" + URL); }
                if (EnSet["result"].ToString() == "ok") {
                               
                if (IsValidIP(EnSet["IP"].ToString()) == "ip4") { UperCheck = sd.UpdateARecord(EnSet["Host"].ToString(), EnSet["Dom"].ToString(), "127.0.0.1"); }
                if (IsValidIP(EnSet["IP"].ToString()) == "ip6") { UperCheck = sd.UpdateIP6(EnSet["Host"].ToString(), EnSet["Dom"].ToString(), "::1");}
                }
}
        EnSet.Close();
        Enlook.Dispose();
      if (UperCheck == "OK") {

          SqlCommand DisAlook = new SqlCommand("Disable_Device @URL='" + URL + "', @UserID='" + Userid + "', @Password='" + Password + "'", Conn);
          SqlDataReader DisASet = DisAlook.ExecuteReader();
        DisASet.Close();
        DisAlook.Dispose();
        Response.Redirect("eddev.aspx?error=disabled&url=" + URL);
          
      } 
          
      else { Response.Redirect("eddev.aspx?error=errt&url=" + URL); } 
        
    }


    Conn.Close();
    Conn.Dispose();
    
%>
<script runat="server">

        //Validate input + cross site scriptng block.
    bool IsOKurl(string input)
    {

        if ((input.Substring(0, 1) == "-") || (input.Substring(input.Length - 1) == "-")) { return false; }

        if ((input == null) || (input == "")) { return false; }
        int nChar;
        input = input.ToLower();
        foreach (char i in input)
        {
            nChar = Convert.ToInt32(i);
            if ((nChar != 45) && (nChar != 46))
            {
                if ((nChar > 47 && nChar < 58) || (nChar > 96 && nChar < 123)) { }
                else { return false; }
            }
        }
        return true;
    }


    string IsValidIP(string addr)
    {
        string valid = "false";
        string pattern = @"^([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3}$";
        string pattern1 = @"\A(?:[0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}\z";
        string pattern2 = @"\A((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?)::((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?)\z";
        string pattern3 = @"\A((?:[0-9A-Fa-f]{1,4}:){6,6})(25[0-5]|2[0-4]\d|[0-1]?\d?\d)(\.(25[0-5]|2[0-4]\d|[0-1]?\d?\d)){3}\z";
        string pattern4 = @"\A((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?) ::((?:[0-9A-Fa-f]{1,4}:)*)(25[0-5]|2[0-4]\d|[0-1]?\d?\d)(\.(25[0-5]|2[0-4]\d|[0-1]?\d?\d)){3}\z";
        Regex check = new Regex(pattern);
        Regex check1 = new Regex(pattern1);
        Regex check2 = new Regex(pattern2);
        Regex check3 = new Regex(pattern3);
        Regex check4 = new Regex(pattern4);
        if (check.IsMatch(addr, 0) == true) { valid = "ip4"; }
        if (check1.IsMatch(addr, 0) == true) { valid = "ip6"; }
        if (check2.IsMatch(addr, 0) == true) { valid = "ip6"; }
        if (check3.IsMatch(addr, 0) == true) { valid = "ip6"; }
        if (check4.IsMatch(addr, 0) == true) { valid = "ip6"; }
        return valid;
    }  
</script>