<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<% 
/////////////////////////////////////////////////////////////////////////////
//                                nic/update/default.aspx
//                            -------------------
//   begin                : Thur, June 14, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: nic/update/default.aspx,v 1.0.0.0 R1
//   Function: Update capture file standard dyndns.org format.
//  
//   Possible Return Values: good
//                           nochg
//                           badauth
//                           nohost
//                           911
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;

MintDNSLib.DNSMANClass sd = new MintDNSLib.DNSMANClass();
SqlConnection Conn = new SqlConnection(ConfigurationSettings.AppSettings["DBCon"]);
Conn.Open(); 

//Decode user name and password 
   String AuthString = "";
   String UserID = "";
   String Password = "";
   String Host = Request["hostname"];
   String MyIP = Request["myip"];
   String ValidIP = "";
   String InUString = Request.ServerVariables["HTTP_Authorization"];
   if ((InUString == null) || (InUString == "")) {
       Response.Status = "401 Not Authorized";
       Response.AddHeader("WWW-Authenticate", "Basic realm=DDNS");
       Conn.Close();
       Conn.Dispose();  
       Response.End();
     }
   else { 
   if (InUString.Substring(0, 5) == "Basic"){AuthString = InUString.Substring(6);}
   if ((AuthString != null) && (AuthString != ""))   {
       AuthString = base64_decode(AuthString);
       string[] User_N_Pass = AuthString.Split(':');
       UserID = User_N_Pass.GetValue(0).ToString().Trim().ToLower();
       Password = User_N_Pass.GetValue(1).ToString().Trim();
   }
   else   {
       Conn.Close();
       Conn.Dispose();  
       Response.Write("911");
       Response.End();
   }        
      }
      //End decode user name and password 

      if ((Host == null) || (Host == ""))
      {
          Conn.Close();
          Conn.Dispose();  
          Response.Write("nohost");
          Response.End();
      }
      else { Host = Host.ToLower(); }

      
      if (UserID != null)
      {
          UserID = UserID.Replace("#", "@");
      }
    
      if ((CharCheck(UserID) == false) || (CharCheck(Password) == false) || (CharCheck(Host) == false)) {
          Conn.Close();
          Conn.Dispose();  
          Response.Write("911");
          Response.End();
      }
      
    
    
      if ((MyIP == null) || (MyIP == "")) {
          MyIP = Request.ServerVariables["HTTP_X_FORWARDED_FOR"];
          if (MyIP != null)
          {
              MyIP = MyIP.ToLower();
              MyIP = MyIP.Trim();
          }

          if ((MyIP == null) || (MyIP == "unknown")) { MyIP = Request.ServerVariables["REMOTE_ADDR"]; }

          else if (MyIP.IndexOf(",") != -1)
          {
              string[] IPs = MyIP.Split(',');
              //MyIP = IPs.GetValue(IPs.Length -1).ToString().Trim();
                MyIP = IPs.GetValue(0).ToString().Trim();
          }
          }


         if (MyIP.Length > 100){
             Conn.Close();
             Conn.Dispose();  
            Response.Write("911");
            Response.End();
          }


         if ((IsValidIP(MyIP) == "false"))
         {
             Conn.Close();
             Conn.Dispose();
             Response.Write("911");
             Response.End();
         }
         else { ValidIP = IsValidIP(MyIP); }


          SqlCommand Ulook = new SqlCommand("CL_User_Check @UserID= '" + UserID + "', @Password='" + base64_encode(Password) + "'", Conn);
          SqlDataReader UlookSet = Ulook.ExecuteReader();
    if (UlookSet.HasRows == false) {
        UlookSet.Close();
        Ulook.Dispose();
        Conn.Close();
        Conn.Dispose();  
            Response.Write("badauth");
            Response.End();
    }
    UlookSet.Close();
    Ulook.Dispose();

    SqlCommand DomUp = new SqlCommand("Client_Update @UserID= '" + UserID + "', @Password='" + base64_encode(Password) + "', @IP='" + MyIP + "', @URL='" + Host + "'", Conn);
    SqlDataReader DomSet = DomUp.ExecuteReader();
    if (DomSet.HasRows == false)
    {
        DomSet.Close();
        DomUp.Dispose();

        Conn.Close();
        Conn.Dispose();
        Response.Write("nohost");
        Response.End();
    }
    while (DomSet.Read())
    {

        if (DomSet["Disabled"].ToString() == "True")
        {

            Response.Write("disabled");
            
        }
        if (DomSet["IP"].ToString() != MyIP)
        {

            if ((IsValidIP(DomSet["IP"].ToString()) == "ip4") && (IsValidIP(MyIP) == "ip4")) { sd.UpdateARecord(DomSet["Host"].ToString(), DomSet["Dom"].ToString(), MyIP); }
            if ((IsValidIP(DomSet["IP"].ToString()) == "ip6") && (IsValidIP(MyIP) == "ip6")) { sd.UpdateIP6(DomSet["Host"].ToString(), DomSet["Dom"].ToString(), MyIP); }
            if ((IsValidIP(DomSet["IP"].ToString()) == "ip6") && (IsValidIP(MyIP) == "ip4"))
            {
                sd.DeleteIP6(DomSet["Host"].ToString(), DomSet["Dom"].ToString());
                sd.CreateARecord(DomSet["Host"].ToString(), DomSet["Dom"].ToString(), MyIP);

            }
            if ((IsValidIP(DomSet["IP"].ToString()) == "ip4") && (IsValidIP(MyIP) == "ip6"))
            {
                sd.DeleteARecord(DomSet["Host"].ToString(), DomSet["Dom"].ToString());
                sd.CreateIP6(DomSet["Host"].ToString(), DomSet["Dom"].ToString(), MyIP);

            }
            Response.Write("good");
           
        }
        if (DomSet["IP"].ToString() == MyIP) { Response.Write("nochg"); }
        

    }

    



    DomSet.Close();
    DomUp.Dispose();

    Conn.Close();
    Conn.Dispose();
    
    
    
    
 %>
 <script runat="server">
    //Validate input + cross site scriptng block.
     bool CharCheck(string input)
        {
            if ((input == null) || (input == "")) { return false; }
         if (input.Length >= 255){ return false; }
            int nChar;
            input = input.ToLower();
            foreach (char i in input)
               {
                nChar = Convert.ToInt32(i);
               
                if ((nChar > 41 && nChar < 59) || (nChar > 63 && nChar < 123) || (nChar > 31 && nChar < 33))
                { }
                else
                { return false; }
                }
                return true;
       }

string base64_encode(string data){
  
       if ((data == null) || (data == "")) { return ""; }  
     try   
        {    
      byte[] encData_byte = new byte[data.Length];  
      encData_byte = System.Text.Encoding.UTF8.GetBytes(data);  
      string encodedData = Convert.ToBase64String(encData_byte); 
      return encodedData;
        }    
  catch(Exception e) {return e.ToString();}
  }

string base64_decode(string data){

       if ((data == null) || (data == "")) { return ""; }
    try
       {
        System.Text.UTF8Encoding encoder = new System.Text.UTF8Encoding();
        System.Text.Decoder utf8Decode = encoder.GetDecoder();
        byte[] todecode_byte = Convert.FromBase64String(data);
        int charCount = utf8Decode.GetCharCount(todecode_byte, 0, todecode_byte.Length);
        char[] decoded_char = new char[charCount];
        utf8Decode.GetChars(todecode_byte, 0, todecode_byte.Length, decoded_char, 0);
        string result = new String(decoded_char);
        return result;
    }
    catch(Exception e){return e.ToString();}
  }

string IsValidIP(string addr)
{
    string valid = "false";
    string pattern = @"^([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3}$";
    string pattern1 = @"\A(?:[0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}\z";
    string pattern2 = @"\A((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?)::((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?)\z";
    string pattern3 = @"\A((?:[0-9A-Fa-f]{1,4}:){6,6})(25[0-5]|2[0-4]\d|[0-1]?\d?\d)(\.(25[0-5]|2[0-4]\d|[0-1]?\d?\d)){3}\z";
    string pattern4 = @"\A((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?) ::((?:[0-9A-Fa-f]{1,4}:)*)(25[0-5]|2[0-4]\d|[0-1]?\d?\d)(\.(25[0-5]|2[0-4]\d|[0-1]?\d?\d)){3}\z";
    Regex check = new Regex(pattern);
    Regex check1 = new Regex(pattern1);
    Regex check2 = new Regex(pattern2);
    Regex check3 = new Regex(pattern3);
    Regex check4 = new Regex(pattern4);
    if (check.IsMatch(addr, 0) == true) { valid = "ip4"; }
    if (check1.IsMatch(addr, 0) == true) { valid = "ip6"; }
    if (check2.IsMatch(addr, 0) == true) { valid = "ip6"; }
    if (check3.IsMatch(addr, 0) == true) { valid = "ip6"; }
    if (check4.IsMatch(addr, 0) == true) { valid = "ip6"; }
    return valid;
}  
    
</script>
