<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<!--#include file="includes/css.aspx"-->

<% 
/////////////////////////////////////////////////////////////////////////////
//                                stepaction.aspx
//                            -------------------
//   begin                : Thur, June 13, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: stepaction.aspx,v 1.0.0.0 R1
//   Function: Device Registration and domain creation functions file.
//
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;  
    
    
MintDNSLib.DNSMANClass sd = new MintDNSLib.DNSMANClass();
if (Request.Cookies["DDNS"] == null) { Response.Redirect("logon.aspx?error=session"); }       
String Userid = Request.Cookies["DDNS"]["user"].ToString();
String Password = Request.Cookies["DDNS"]["pass"].ToString();
String Limit = "";
String UDevs = "";
String Dom = Request["Dom"];
String Host = Request["Host"].Trim().ToLower();
String ValidIP = "";
String MyIP = Request.ServerVariables["HTTP_X_FORWARDED_FOR"];
SqlConnection Conn = new SqlConnection(ConfigurationSettings.AppSettings["DBCon"]);
Conn.Open();


SqlCommand Ulook = new SqlCommand("User_Lookup @UserID='" + Userid + "', @Password='" + Password + "'", Conn);
SqlDataReader UlookSet = Ulook.ExecuteReader();
    if (UlookSet.HasRows == false) { Response.Redirect("logon.aspx?error=session"); }
    UlookSet.Close();
    Ulook.Dispose();
     
    //IP detection
    if (MyIP != null)
    {
        MyIP = MyIP.ToLower();
        MyIP = MyIP.Trim();
    }

    if ((MyIP == null) || (MyIP == "unknown")) { MyIP = Request.ServerVariables["REMOTE_ADDR"]; }

    else if (MyIP.IndexOf(",") != -1)
    {
        string[] IPs = MyIP.Split(',');
        //MyIP = IPs.GetValue(IPs.Length -1).ToString().Trim();
          MyIP = IPs.GetValue(0).ToString().Trim();
    }
    if (IsValidIP(MyIP) == "false") { Response.Redirect("step.aspx?error=input"); }
    else { ValidIP = IsValidIP(MyIP); }
    
    //Max records check
    SqlCommand Reclook = new SqlCommand("Rec_Block @UserID='" + Userid + "'", Conn);
    SqlDataReader RecSet = Reclook.ExecuteReader();
    while (RecSet.Read()) {
     Limit = RecSet["MaxRec"].ToString();
     UDevs = RecSet["RegDevs"].ToString();
    }
    RecSet.Close();
    Reclook.Dispose();

        if (Convert.ToInt32(UDevs) >= Convert.ToInt32(Limit)) { Response.Redirect("step.aspx?error=limit"); }
        if ((Host == null) || (Host == "") || (Dom == null) || (Dom == "")) { Response.Redirect("step.aspx?error=fields"); }
        if (IsOKinput(Host) == false) { Response.Redirect("step.aspx?error=input");}

        SqlCommand DomCLook = new SqlCommand("Look_Single_Dom @Dom='" + Dom + "', @UserID='" + Userid + "'", Conn);
        SqlDataReader DomCSet = DomCLook.ExecuteReader();
    if (DomCSet.HasRows == false) { Response.Redirect("logon.aspx?error=dom"); }
    DomCSet.Close();
    DomCLook.Dispose();

String CreResult = "";
if (ValidIP == "ip4"){CreResult = sd.CreateARecord(Host, Dom, MyIP);}
else if (ValidIP == "ip6"){CreResult = sd.CreateIP6(Host, Dom, MyIP);}



   if (CreResult == "EXPIRED") { Response.Redirect ("step.aspx?error=expire");}
   if (CreResult == "OK")
        {
            SqlCommand CreLook = new SqlCommand("Add_Device @Host='" + Host + "', @Dom='" + Dom + "', @UserID='" + Userid + "', @Password='" + Password + "', @Type='" + "A" + "', @IP='" + MyIP + "'", Conn);
            SqlDataReader CreSet = CreLook.ExecuteReader();
    if (CreSet.HasRows == false) { Response.Redirect("devices.aspx?error=created"); }
    else {Response.Redirect("step.aspx?error=dom");}
    CreSet.Close();
    CreLook.Dispose();   
        }
   else { Response.Redirect ("step.aspx?error=dom");}

        Conn.Close();
        Conn.Dispose();
%>
<script runat="server">
    //Validate input + cross site scriptng block.
   bool IsOKinput(string input){

   if ((input.Substring(0,1) == "-") || (input.Substring(input.Length - 1) == "-")){ return false;}
          
          if ((input == null) || (input == "")) { return false; }
          if (input.Length >= 64) { return false; }
            int nChar;
            input = input.ToLower();
            foreach (char i in input)
               {
                nChar = Convert.ToInt32(i);
                   if (nChar != 45) {
              if ((nChar > 47 && nChar < 58) || (nChar > 96 && nChar < 123)) { }   
              else { return false; }
                   }   
                }
                return true;   
            }

   string IsValidIP(string addr)
   {
       string valid = "false";
       string pattern = @"^([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3}$";
       string pattern1 = @"\A(?:[0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}\z";
       string pattern2 = @"\A((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?)::((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?)\z";
       string pattern3 = @"\A((?:[0-9A-Fa-f]{1,4}:){6,6})(25[0-5]|2[0-4]\d|[0-1]?\d?\d)(\.(25[0-5]|2[0-4]\d|[0-1]?\d?\d)){3}\z";
       string pattern4 = @"\A((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?) ::((?:[0-9A-Fa-f]{1,4}:)*)(25[0-5]|2[0-4]\d|[0-1]?\d?\d)(\.(25[0-5]|2[0-4]\d|[0-1]?\d?\d)){3}\z";
       Regex check = new Regex(pattern);
       Regex check1 = new Regex(pattern1);
       Regex check2 = new Regex(pattern2);
       Regex check3 = new Regex(pattern3);
       Regex check4 = new Regex(pattern4);
       if (check.IsMatch(addr, 0) == true) { valid = "ip4"; }
       if (check1.IsMatch(addr, 0) == true) { valid = "ip6"; }
       if (check2.IsMatch(addr, 0) == true) { valid = "ip6"; }
       if (check3.IsMatch(addr, 0) == true) { valid = "ip6"; }
       if (check4.IsMatch(addr, 0) == true) { valid = "ip6"; }
       return valid;
   }  
            
            
</script>