Imports System.Xml
'Imports System.Data.OleDb
Imports System.Management
Imports System.Security.Cryptography.X509Certificates
Imports System.Net.Security
Module Functions

    Public Hours As Short
    Public Minutes As Short


    Public Function ValidateRemoteCertificate(ByVal sender As Object, ByVal certificate As X509Certificate, ByVal chain As X509Chain, ByVal sslPolicyErrors As SslPolicyErrors) As Boolean
        Return False
    End Function

    Public Function ValidIP(ByVal IP As String) As Boolean

        Dim temp() As String
        Dim X As Integer
        Try
            If Not IP Like "*.*.*.*" Then Exit Function
            temp = Split(IP, ".")
            If UBound(temp) = 3 Then
                For X = 0 To UBound(temp)
                    If Trim(temp(X)) = vbNullString Or Not IsNumeric(temp(X)) Then Exit Function
                    Select Case X
                        Case 0
                            If temp(X) > 223 Or temp(X) <= 0 Then Exit Function
                        Case 1 To 3
                            If temp(X) > 255 Or temp(X) < 0 Then Exit Function
                    End Select
                Next X
            End If
            ValidIP = True

        Catch
            CreateError(Err.Description + " " + Err.Source, Err.Number)
        End Try

    End Function

    Public Function FindIPInString(ByRef statspage As String, Optional ByRef Keyword As String = "") As String
        FindIPInString = vbNullString
        Dim temp() As String
        Dim X As Object = 0
        Dim Y As Short
        Try
            If Trim(statspage) = vbNullString Then GoTo clean
            If Trim(Keyword) IsNot vbNullString Then
                X = InStr(statspage, Keyword)
            End If

            'If X = 0 Then X = 1
            If X = 0 Then
                FindIPInString = "Keyword not found"
                Exit Function
            End If
            Do Until X > Len(statspage)
                Do Until Mid(statspage, X, 15) Like "*.*.*.*" And IsNumeric(Mid(statspage, X, 1)) Or X > Len(statspage)
                    X = X + 1
                Loop
                If X > Len(statspage) Then GoTo clean
                temp = Split(Mid(statspage, X, 15), ".") : Y = 1
                Do Until Not IsNumeric(Mid(temp(3), Y, 1)) Or Y > Len(temp(3))
                    Y = Y + 1
                Loop
                temp(3) = Mid(temp(3), 1, Y - 1)
                For Y = 0 To 3
                    FindIPInString = IIf(Trim(FindIPInString) = vbNullString, vbNullString, FindIPInString & ".") & temp(Y)
                    If Not IsNumeric(temp(Y)) Then Exit For
                Next Y
                If ValidIP(FindIPInString) Or FindIPInString = "0.0.0.0" Then Exit Do Else FindIPInString = vbNullString
                X = X + 1
            Loop
clean:
            If Not Trim(FindIPInString) Like "*.*.*.*" Then FindIPInString = "0.0.0.0"

        Catch
            CreateError(Err.Description + " " + Err.Source, Err.Number)
        End Try

    End Function
    Private Function Lefty(ByVal str As String, ByVal index As Integer) As String
        Lefty = str.Substring(0, index)
    End Function

    Private Function Righty(ByVal str As String, ByVal index As Integer) As String
        Righty = str.Substring(str.Length - index)
    End Function

    Public Function CheckDaily(ByRef tempTimeNow As String) As Boolean
        Try
            Dim SwitchIt As Boolean
            Dim tempTime As Integer ' in minutes

            Dim tempTimeNowMin As Integer ' in minutes
            Dim tempMinutes As Integer ' hours*60 + minutes (in minutes)
            SwitchIt = False
            If Hours = 0 And Minutes = 0 Then ' got loaded b/c the loadsettings function activated a label or something
                CheckDaily = False
                Exit Function
            End If
            tempTime = CInt(CInt(Lefty(FormatDateTime(TimeOfDay, DateFormat.ShortTime), 2)) * 60) + CInt(Righty(FormatDateTime(TimeOfDay, DateFormat.ShortTime), 2))
            tempTimeNowMin = CInt(CInt(Lefty(tempTimeNow, 2)) * 60) + CInt(Righty(tempTimeNow, 2))
            tempMinutes = CInt((Hours * 60) + Minutes)
            If tempTime >= tempTimeNowMin + tempMinutes Then
                SwitchIt = True
            Else
                If tempTime - tempMinutes + CInt(24 * 60) <= tempTimeNowMin Then
                    SwitchIt = True
                End If
            End If
            CheckDaily = SwitchIt
        Catch
            CreateError(Err.Description + " " + Err.Source, Err.Number)
        End Try

    End Function
    Public Function CreateInformational(ByVal msg As String, ByVal evID As Integer) As Object
        Dim Log As New EventLog
        Log.Source = "DDNS Enterprise Client"
        Log.WriteEntry(msg, EventLogEntryType.Information, evID)
        Return Nothing
    End Function

    Public Function CreateWarning(ByVal msg As String, ByVal evID As Integer) As Object
        Dim Log As New EventLog
        Log.Source = "DDNS Enterprise Client"
        Log.WriteEntry(msg, EventLogEntryType.Warning, evID)
        Return Nothing
    End Function

    Public Function CreateError(ByVal msg As String, ByVal evID As Integer) As Object
        Dim Log As New EventLog
        Log.Source = "DDNS Enterprise Client"
        Log.WriteEntry(msg, EventLogEntryType.Error, evID)
        Return Nothing
    End Function
    Public Function App_Path() As String
        Return System.AppDomain.CurrentDomain.BaseDirectory()
    End Function
    Public Function Connect(ByRef URL As String, Optional ByVal UserID As String = "", Optional ByVal Password As String = "") As String

        Try

            System.Net.ServicePointManager.ServerCertificateValidationCallback = AddressOf ValidateRemoteCertificate
            Dim myCred As New Net.NetworkCredential(UserID, Password)
            If Not My.Computer.Network.IsAvailable = True Then
                Connect = "Offline"
                Exit Function
            End If
            Dim Request As Net.HttpWebRequest

            Request = CType(System.Net.HttpWebRequest.Create(URL), System.Net.HttpWebRequest)
            Request.UserAgent = "DDNS"
            Request.Method = "GET"
            Request.Credentials = myCred
            Dim HttpWResponse As Net.HttpWebResponse = Request.GetResponse()
            Dim strm As IO.Stream = HttpWResponse.GetResponseStream()
            Dim sr As IO.StreamReader = New IO.StreamReader(strm)
            Dim sText As String = sr.ReadToEnd()
            Connect = sText
            strm.Close()
            Request = Nothing
            HttpWResponse = Nothing
            strm = Nothing
            sr = Nothing
        Catch
            Connect = "Failed"
            CreateError(Err.Description + " " + Err.Source, Err.Number)
        End Try

    End Function

 
    Public Function ReadDoms() As Boolean
        'Dim Server As String = ""
        'Dim Response As String = ""
        'Dim SQL As OleDbCommand
        'Dim RSet As OleDbDataReader

        'Dim UpdateRNot As Boolean = False
        'Dim LConn As OleDbConnection = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & System.AppDomain.CurrentDomain.BaseDirectory() & "progdb.mdb;")

        'Try



        'Sql = New OleDbCommand("Select Server From Settings", LConn)
        'LConn.Open()
        'RSet = Sql.ExecuteReader
        'If RSet.HasRows = False Then
        'Exit Function
        'Else
        'While RSet.Read
        'Server = RSet("Server").ToString
        'End While
        'End If
        'RSet.Close()
        'LConn.Close()
        'Response = Connect(Server + "/update/progdef.aspx")
        'If Not Response = "Failed" Or Response = "Offline" Then
        'If Not Response = "3.0" Then Process.Start(System.AppDomain.CurrentDomain.BaseDirectory() + "Updater.exe")
        'End If
        'Catch ex As Exception
        'CreateError(Err.Description & " Update_Look " & Err.Source, Err.Number)
        'End Try
    End Function

    Public Function Maintain_IP_Detect() As Boolean
        Try

            '<detection>
            '<name>Default Detection</name>0
            '<url>ipcheck.aspx</url>1
            '<keyword></keyword>2
            '<IP></IP>3
            '<user></user>4
            '<pass></pass>5
            '<method>Default</method>6
            '<status>Operational</status>7
            '<date>6/11/2014</date>8
            '<uprnot>0</uprnot>9
            '<a_index></a_index>10
            '</detection>
            Dim m_xmld As XmlDocument = New XmlDocument()
            m_xmld.Load("c:\\mintdata\\mintdns.xml")
            Dim m_nodelist As XmlNodeList
            Dim m_node As XmlNode
            'Read all Doms
            m_nodelist = m_xmld.SelectNodes("main/detection")
            For Each m_node In m_nodelist
                Dim Meth = m_node.ChildNodes.Item(6).InnerText

                If Meth = "Adapter" Then
                    TAdapter(m_node.ChildNodes.Item(0).InnerText, m_node.ChildNodes.Item(10).InnerText)
                End If
                If Meth = "Router" Then

                    UPDetect(m_node.ChildNodes.Item(0).InnerText, m_node.ChildNodes.Item(1).InnerText, m_node.ChildNodes.Item(2).InnerText, m_node.ChildNodes.Item(4).InnerText, m_node.ChildNodes.Item(5).InnerText)
                End If
                If Meth = "Default" Then

                    DefaultDetect()
                End If


            Next

        Catch
            CreateError(Err.Description & " Maintain_IP_Detect " & Err.Source, Err.Number)
        End Try
    End Function


    Private Function TAdapter(ByVal Name As String, ByVal IndexA As String) As Boolean


        Dim UpdateRNot As Boolean = False
        Try



            Dim oSearcher As New System.Management.ManagementObjectSearcher("select * from Win32_NetworkAdapterConfiguration where index = " & IndexA & " ")
            Dim oObject As System.Management.ManagementObject
            Dim sIP() As String
            Dim oldIP As String = ""
            Dim Fin_IP As String = ""
            Dim Index As String = ""
            Dim Desc As String = ""
            Dim sString As String = ""
            Dim sMessage As String = ""
            For Each oObject In oSearcher.Get
                Index = Nothing
                Desc = Nothing
                sIP = Nothing
                If Not oObject("ipaddress") Is Nothing Then Index = oObject("Index")
                If Not oObject("ipaddress") Is Nothing Then Desc = oObject("Description")
                If Not oObject("ipaddress") Is Nothing Then sIP = oObject("ipaddress")
                If Not Index = "" Then
                    For Each sString In sIP
                        Fin_IP = sString
                    Next
                End If
            Next
            sMessage = ValidIP(Fin_IP)

            '<detection>
            '<name>Default Detection</name>0
            '<url>ipcheck.aspx</url>1
            '<keyword></keyword>2
            '<IP></IP>3
            '<user></user>4
            '<pass></pass>5
            '<method>Default</method>6
            '<status>Operational</status>7
            '<date>6/11/2014</date>8
            '<uprnot>0</uprnot>9
            '<a_index></a_index>10
            '</detection>
            Dim m_xmld As XmlDocument = New XmlDocument()
            m_xmld.Load("c:\\mintdata\\mintdns.xml")
            Dim Remover As XmlNode
            Remover = m_xmld.SelectSingleNode("main/detection[name='" & Name & "']")

            If Remover Is Nothing Then
                Exit Function
            Else
                oldIP = Remover.ChildNodes.Item(3).InnerText
            End If

            If Not Fin_IP = oldIP Then

                If sMessage = True Then
                    UpdateRNot = True
                    CreateInformational("An IP change was detected: " + Name, 111)
                    'SQL = New OleDbCommand("UPDATE IP_Detection SET IP = '" & Fin_IP & "', UpRNot = " & UpdateRNot.ToString & " Where (Ident = '" & Name & "')", BConn)
                    Remover.ChildNodes(3).InnerText = Fin_IP
                    Remover.ChildNodes(9).InnerText = UpdateRNot.ToString
                    m_xmld.Save("c:\\mintdata\\mintdns.xml")
                Else
                    'SQL = New OleDbCommand("UPDATE IP_Detection SET Status = 'Inoperable' Where (Ident = '" & Name & "')", BConn)
                    Remover.ChildNodes(7).InnerText = "Inoperable"
                    m_xmld.Save("c:\\mintdata\\mintdns.xml")
                End If
            End If

        Catch
            CreateError(Err.Description & " TAdapter " & Err.Source, Err.Number)
        End Try

    End Function

    


    Public Function UPDetect(ByVal Name As String, ByVal URL As String, Optional ByVal Keyword As String = "", Optional ByVal User As String = "", Optional ByVal Password As String = "") As Boolean

        '<detection>
        '<name>Default Detection</name>0
        '<url>ipcheck.aspx</url>1
        '<keyword></keyword>2
        '<IP></IP>3
        '<user></user>4
        '<pass></pass>5
        '<method>Default</method>6
        '<status>Operational</status>7
        '<date>6/11/2014</date>8
        '<uprnot>0</uprnot>9
        '<a_index></a_index>10
        '</detection>
        Dim oldIP As String = ""

        Try

            Dim m_xmld As XmlDocument = New XmlDocument()
            m_xmld.Load("c:\\mintdata\\mintdns.xml")
            Dim Remover As XmlNode
            Remover = m_xmld.SelectSingleNode("main/detection[name='" & Name & "']")
            If Remover Is Nothing Then
                Exit Function
            End If
            Dim Page As String = ""
            Dim F_IP As String = ""
            Dim IsVal As Boolean = False
            Page = Connect(URL, User, Password)
            If Page = "Failed" Then

                Remover.ChildNodes(7).InnerText = "Inoperable"
                m_xmld.Save("c:\\mintdata\\mintdns.xml")
                'Sql = New OleDbCommand("UPDATE IP_Detection SET Status = 'Inoperable' Where (Ident = '" & Name & "')", AConn)

                Exit Function
            End If
            F_IP = FindIPInString(Page, Keyword)
            If F_IP = "Keyword not found" Then
                Remover.ChildNodes(7).InnerText = "Inoperable"
                m_xmld.Save("c:\\mintdata\\mintdns.xml")
                Exit Function
            End If
            IsVal = ValidIP(F_IP)

            oldIP = Remover.ChildNodes(3).InnerText


            If Not F_IP = oldIP Then
                If IsVal = False Then
                    'Sql = New OleDbCommand("UPDATE IP_Detection SET Status = 'Inoperable' Where (Ident = '" & Name & "')", AConn)
                    Remover.ChildNodes(7).InnerText = "Inoperable"
                    m_xmld.Save("c:\\mintdata\\mintdns.xml")
                    Exit Function
                Else
                    UpdateRNot = True
                    CreateInformational("An IP change was detected: " + Name, 111)
                    'Sql = New OleDbCommand("UPDATE IP_Detection SET IP = '" & F_IP & "', UpRNot = " & UpdateRNot.ToString & " Where (Ident = '" & Name & "')", AConn)
                    Remover.ChildNodes(3).InnerText = F_IP
                    Remover.ChildNodes(9).InnerText = UpdateRNot.ToString
                    m_xmld.Save("c:\\mintdata\\mintdns.xml")
                    Exit Function
                End If
            End If

        Catch
            CreateError(Err.Description & " UPDetect " & Err.Source, Err.Number)
        End Try
    End Function

    

    Public Function Send_Updates() As Boolean
        Dim UserId As String = ""
        Dim Pass As String = ""
        Dim Server As String = ""
        Dim Response As String = ""

        Dim UpdateRNot As Boolean = False

        Try

            'SQL = New OleDbCommand("Select Server, UserID, Pass From Settings", LConn)
            Dim m_xmld As XmlDocument = New XmlDocument()
            m_xmld.Load("c:\\mintdata\\mintdns.xml")
            Dim ServLook As XmlNode
            ServLook = m_xmld.SelectSingleNode("main/settings")
            If ServLook Is Nothing Then
                Exit Function
            Else
                Server = ServLook.ChildNodes(0).InnerText
                UserId = ServLook.ChildNodes(3).InnerText
                Pass = ServLook.ChildNodes(4).InnerText
            End If

            'Sql = New OleDbCommand("SELECT A1.URL, A1.Method, A2.IP, A2.UpRNot FROM Domains A1, IP_Detection A2 WHERE A1.Method = A2.Ident And A1.IP Not Like A2.IP", LConn)
            '<domain>
            '  <url>john-link.myfreeip.me</url>0
            '  <IP>173.225.3.36</IP>1
            '  <disabled>False</disabled>2
            ' <method>Default</method>3
            '</domain>
            Dim m_nodelist As XmlNodeList
            Dim m_node As XmlNode
            m_nodelist = m_xmld.SelectNodes("main/domain")
            If m_nodelist Is Nothing Then
                Exit Function
            Else
                Dim Detectlookup As XmlNode
                For Each m_node In m_nodelist
                    Dim URL = m_node.ChildNodes.Item(0).InnerText
                    Dim IP = m_node.ChildNodes.Item(1).InnerText
                    Dim DISABLED = m_node.ChildNodes.Item(2).InnerText
                    Dim Meth = m_node.ChildNodes.Item(3).InnerText
                    '<detection>
                    '<name>Default Detection</name>0
                    '<url>ipcheck.aspx</url>1
                    '<keyword></keyword>2
                    '<IP></IP>3
                    '<user></user>4
                    '<pass></pass>5
                    '<method>Default</method>6
                    '<status>Operational</status>7
                    '<date>6/11/2014</date>8
                    '<uprnot>0</uprnot>9
                    '</detection>
                    If Not Meth = "Exclude From Update" Then

                        If Meth = "Default Detection Method" Then
                            Detectlookup = m_xmld.SelectSingleNode("main/detection[name='Default Detection Method']")
                            If Not Detectlookup Is Nothing Then
                                If Not IP = Detectlookup.ChildNodes(3).InnerText Then
                                    CreateInformational("A DDNS update was performed for the domain: " + URL, 111)
                                    Dim ResponseA As String = ""
                                    UpdateRNot = False
                                    ResponseA = Connect(Server + "/client/update.aspx?host=" + URL + "", UserId, Pass)
                                    If ResponseA = "ok" Then
                                        m_node.ChildNodes(1).InnerText = Detectlookup.ChildNodes(3).InnerText
                                        Detectlookup.ChildNodes(9).InnerText = UpdateRNot
                                        m_xmld.Save("c:\\mintdata\\mintdns.xml")
                                    End If
                                End If
                            End If
                        Else

                            Detectlookup = m_xmld.SelectSingleNode("main/detection[name='" + Meth + "']")
                            If Not Detectlookup Is Nothing Then
                                If Not IP = Detectlookup.ChildNodes(3).InnerText Then
                                    CreateInformational("A DDNS update was performed for the domain: " + URL, 111)
                                    Dim ResponseB As String = ""
                                    UpdateRNot = False
                                    ResponseB = Connect(Server + "/client/update.aspx?host=" + URL + "&myip=" + Detectlookup.ChildNodes(3).InnerText, UserId, Pass)
                                    If ResponseB = "ok" Then
                                        m_node.ChildNodes(1).InnerText = Detectlookup.ChildNodes(3).InnerText
                                        Detectlookup.ChildNodes(9).InnerText = UpdateRNot
                                        m_xmld.Save("c:\\mintdata\\mintdns.xml")
                                    End If
                                End If
                            End If
                            End If

                    End If




                Next
            End If

            'If RSet("UpRNot").ToString = True Then




        Catch
            CreateError(Err.Description & " Send-Updates " & Err.Source, Err.Number)
        End Try
    End Function

    

    Private Function DefaultDetect() As Boolean
        '<detection>
        '<name>Default Detection</name>0
        '<url>ipcheck.aspx</url>1
        '<keyword></keyword>2
        '<IP></IP>3
        '<user></user>4
        '<pass></pass>5
        '<method>Default</method>6
        '<status>Operational</status>7
        '<date>6/11/2014</date>8
        '<uprnot>0</uprnot>9
        '<a_index></a_index>10
        '</detection>
        Dim UpdateRNot As Boolean = False
        Try

            Dim m_xmld As XmlDocument = New XmlDocument()
            m_xmld.Load("c:\\mintdata\\mintdns.xml")

            Dim sIP As String = ""
            Dim oldIP As String = ""
            Dim Fin_IP As String = ""
            Dim Index As String = ""
            Dim Server As String = ""
            Dim Desc As String = ""
            Dim sString As String = ""
            Dim sMessage As String = ""
            Dim NewIP As String = ""
            ''''
            'SQL = New OleDbCommand("Select Server from Settings", BConn)
            Dim ServLook As XmlNode
            ServLook = m_xmld.SelectSingleNode("main/settings")
            If ServLook Is Nothing Then
                Exit Function
            Else
                Server = ServLook.ChildNodes.Item(0).InnerText
            End If

            'Sql = New OleDbCommand("SELECT IP from IP_Detection Where (Ident = 'Default Detection Method')", BConn)
            Dim Remover As XmlNode
            Remover = m_xmld.SelectSingleNode("main/detection[name='Default Detection Method']")
            If Remover Is Nothing Then
                Exit Function
            Else
                oldIP = Remover.ChildNodes.Item(3).InnerText
            End If



            NewIP = Connect(Server + "/ipcheck.aspx", "", "")
            sMessage = ValidIP(oldIP)
            sIP = ValidIP(NewIP)


            'If sMessage = True And sIP = True Then
            If Not oldIP = NewIP Then
                UpdateRNot = True
                CreateInformational("An IP change was detected: Default Connection Method", 111)
                ' Sql = New OleDbCommand("UPDATE IP_Detection SET IP = '" & NewIP & "', UpRNot = " & UpdateRNot.ToString & " Where (Ident = 'Default Detection Method')", BConn)
                Remover.ChildNodes(3).InnerText = NewIP
                Remover.ChildNodes(9).InnerText = UpdateRNot.ToString
                m_xmld.Save("c:\\mintdata\\mintdns.xml")
            End If
            'End If


        Catch
            CreateError(Err.Description & " Default-Detect " & Err.Source, Err.Number)
        End Try

    End Function


End Module
